Index: branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfphy.F90
===================================================================
--- branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfphy.F90	(revision 8054)
+++ branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfphy.F90	(revision 8055)
@@ -11,8 +11,9 @@
    !!   zdf_phy       : upadate at each time-step the vertical mixing coeff. 
    !!----------------------------------------------------------------------
-   USE par_oce        ! ocean parameters
+   USE oce            ! ocean dynamics and tracers variables
    USE zdf_oce        ! vertical physics: shared variables         
    USE zdfbfr         ! vertical physics: bottom friction
-   USE zdfric         ! vertical physics: Richardson vertical mixing   
+   USE zdfsh2         ! vertical physics: shear production term of TKE
+   USE zdfric         ! vertical physics: RIChardson dependent vertical mixing   
    USE zdftke         ! vertical physics: TKE vertical mixing
    USE zdfgls         ! vertical physics: GLS vertical mixing
@@ -44,5 +45,9 @@
    INTEGER, PARAMETER ::   np_TKE = 3   ! Turbulente Kinetic Eenergy closure scheme for Kz
    INTEGER, PARAMETER ::   np_GLS = 4   ! Generic Length Scale closure scheme for Kz
-      
+
+   LOGICAL ::   l_zdfsh2   ! shear production term flag (=F for CST, =T otherwise (i.e. TKE, GLS, RIC))
+
+   !! * Substitutions
+#  include "domain_substitute.h90"   
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2017)
@@ -61,4 +66,5 @@
       !!                set horizontal shape and vertical profile of background mixing coef.
       !!----------------------------------------------------------------------
+      INTEGER ::   jk            ! dummy loop indices
       INTEGER ::   ioptio, ios   ! local integers
       !!
@@ -90,7 +96,7 @@
          WRITE(numout,*) '      vertical closure scheme'
          WRITE(numout,*) '         constant vertical mixing coefficient    ln_zdfcst = ', ln_zdfcst
-         WRITE(numout,*) '         constant vertical mixing coefficient    ln_zdfric = ', ln_zdfric
-         WRITE(numout,*) '         constant vertical mixing coefficient    ln_zdftke = ', ln_zdftke
-         WRITE(numout,*) '         constant vertical mixing coefficient    ln_zdfgls = ', ln_zdfgls
+         WRITE(numout,*) '         Richardson number dependent closure     ln_zdfric = ', ln_zdfric
+         WRITE(numout,*) '         Turbulent Kinetic Energy closure (TKE)  ln_zdftke = ', ln_zdftke
+         WRITE(numout,*) '         Generic Length Scale closure (GLS)      ln_zdfgls = ', ln_zdfgls
          WRITE(numout,*) '      convection: '
          WRITE(numout,*) '         enhanced vertical diffusion             ln_zdfevd = ', ln_zdfevd
@@ -137,6 +143,13 @@
       ENDIF
       !
-      !                                   ! set 1st/last level Av to zero one for all
-      avt(:,:,1) = 0._wp   ;   avs(:,:,1) = 0._wp   ;   avm(:,:,1) = 0._wp
+      DO jk = 1, jpk                      ! set turbulent closure Kz to the background value (avt_k, avm_k)
+         avt_k(:,:,jk) = avtb_2d(:,:) * avtb(jk) * wmask (:,:,jk)
+         avm_k(:,:,jk) =                avmb(jk) * wmask (:,:,jk)
+      END DO
+!!gm  to be tested only the 1st & last levels
+!      avt  (:,:, 1 ) = 0._wp   ;   avs(:,:, 1 ) = 0._wp   ;   avm  (:,:, 1 ) = 0._wp
+!      avt  (:,:,jpk) = 0._wp   ;   avs(:,:,jpk) = 0._wp   ;   avm  (:,:,jpk) = 0._wp
+!!gm
+      avt  (:,:,:) = 0._wp   ;   avs(:,:,:) = 0._wp   ;   avm  (:,:,:) = 0._wp
 
       !                          !==  Convection  ==!
@@ -170,4 +183,8 @@
       IF( ln_zdfric .OR. ln_zdfgls )    CALL ctl_stop( 'zdf_phy_init: zdfric and zdfgls never tested with ice shelves cavities ' )
       ENDIF
+      !                                ! shear production term flag
+      IF( ln_zdfcst ) THEN   ;   l_zdfsh2 = .FALSE.
+      ELSE                   ;   l_zdfsh2 = .TRUE.
+      ENDIF
 
       !                          !== gravity wave-driven mixing  ==!
@@ -200,62 +217,90 @@
       !
       INTEGER ::   ji, jj, jk   ! dummy loop indice
+!!OMP      REAL(wp), DIMENSION(WRK_3D) ::   zsh2   ! shear production
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   zsh2   ! shear production
       !! ---------------------------------------------------------------------
+      !      
+!!OMP ===>>>>   Open-MP   to be defined elsewhere   
+      !
+      INTEGER ::   ARG_2D
+      !
+#if defined key_vectopt_loop
+      k_Istr = 1   ;   k_Iend = jpi
+#else
+      k_Istr = 2   ;   k_Iend = jpim1
+#endif
+      k_Jstr = 2   ;   k_Jend = jpjm1
+      !
+!!OMP <<<<===   end
+      
+      ALLOCATE( zsh2(WRK_3D) )
+      
+      
       !
       CALL zdf_bfr( kt )                        !* bottom friction (if quadratic)
-      !                       
+      !
+
+      !                          !==  Kz from chosen turbulent closure  ==!   (avm_k, avt_k)
+      
+      IF( l_zdfsh2 )   &                        !* shear production at w-points (energy conserving form)
+         CALL zdf_sh2( ARG_2D, ub, vb, un, vn, avm_k,   &   ! <<== in  fields
+            &                                   zsh2    )   ! ==>> out field  : shear production
+
+      !
       SELECT CASE ( nzdf_phy )                  !* Vertical eddy viscosity and diffusivity coefficients at w-points
-      CASE( np_RIC )   ;   CALL zdf_ric( kt )         ! Richardson number dependent Kz
-      CASE( np_TKE )   ;   CALL zdf_tke( kt )         ! TKE closure scheme for Kz
-      CASE( np_GLS )   ;   CALL zdf_gls( kt )         ! GLS closure scheme for Kz
+      CASE( np_RIC )   ;   CALL zdf_ric( ARG_2D, kt, gdept_n, zsh2, avm_k, avt_k )         ! Richardson number dependent Kz
+      CASE( np_TKE )   ;   CALL zdf_tke( ARG_2D, kt         , zsh2, avm_k, avt_k )         ! TKE closure scheme for Kz
+      CASE( np_GLS )   ;   CALL zdf_gls( ARG_2D, kt         , zsh2, avm_k, avt_k )         ! GLS closure scheme for Kz
       CASE( np_CST )                                  ! Constant Kz (reset avt, avm to the background value)
-         avt(2:jpim1,2:jpjm1,1:jpkm1) = rn_avt0 * wmask(2:jpim1,2:jpjm1,1:jpkm1)
-         avm(2:jpim1,2:jpjm1,1:jpkm1) = rn_avm0 * wmask(2:jpim1,2:jpjm1,1:jpkm1)
+         ! avt_k and avm_k set one for all at initialisation phase
+!!gm         avt_k(WRK_3D) = rn_avt0 * wmask(WRK_3D)
+!!gm         avm_k(WRK_3D) = rn_avm0 * wmask(WRK_3D)
       END SELECT
+      !  
+      !                          !==  ocean Kz  ==!   (avt, avs, avm)
+      !
+      !                                         !* start from turbulent closure values
+      avt(WRK_2D,2:jpkm1) = avt_k(WRK_2D,2:jpkm1)
+      avm(WRK_2D,2:jpkm1) = avm_k(WRK_2D,2:jpkm1)
       !
       IF( ln_rnf_mouth ) THEN                   !* increase diffusivity at rivers mouths
          DO jk = 2, nkrnf
-            avt(:,:,jk) = avt(:,:,jk) + 2._wp * rn_avt_rnf * rnfmsk(:,:) * wmask(:,:,jk)
+            avt(WRK_2D,jk) = avt(WRK_2D,jk) + 2._wp * rn_avt_rnf * rnfmsk(WRK_2D) * wmask(WRK_2D,jk)
          END DO
       ENDIF
       !
-      IF( ln_zdfevd )   CALL zdf_evd( kt )      !* convection: enhanced vertical eddy diffusivity
+      IF( ln_zdfevd )   CALL zdf_evd( ARG_2D, kt, avm, avt )      !* convection: enhanced vertical eddy diffusivity
       !
       !                                         !* double diffusive mixing
       IF( ln_zdfddm ) THEN                            ! update avt and compute avs
-                        CALL zdf_ddm( kt )
+                        CALL zdf_ddm( ARG_2D, kt, avm, avt, avs )
       ELSE                                            ! same mixing on all tracers
-         avs(2:jpim1,2:jpjm1,1:jpkm1) = avt(2:jpim1,2:jpjm1,1:jpkm1)
+         avs(WRK_3D) = avt(WRK_3D)
       ENDIF
       !
       !                                         !* wave-induced mixing 
-      IF( ln_zdfswm )   CALL zdf_swm( kt )            ! surface  wave (Qiao et al. 2004) 
-      IF( ln_zdfiwm )   CALL zdf_iwm( kt )            ! internal wave (de Lavergne et al 2017)
+      IF( ln_zdfswm )   CALL zdf_swm( ARG_2D, kt, avm, avt, avs )   ! surface  wave (Qiao et al. 2004) 
+      IF( ln_zdfiwm )   CALL zdf_iwm( ARG_2D, kt, avm, avt, avs )   ! internal wave (de Lavergne et al 2017)
 
 
       !                                         !* Lateral boundary conditions (sign unchanged)
-      CALL lbc_lnk( avm, 'W', 1. )
-      CALL lbc_lnk( avt, 'W', 1. )
-      CALL lbc_lnk( avs, 'W', 1. )
-      !
-!!gm  ===>>>   TO BE REMOVED 
-      DO jk = 1, jpkm1            !* vertical eddy viscosity at wu- and wv-points
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-               avmu(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji+1,jj  ,jk) ) * wumask(ji,jj,jk)
-               avmv(ji,jj,jk) = 0.5 * ( avm(ji,jj,jk) + avm(ji  ,jj+1,jk) ) * wvmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-      CALL lbc_lnk( avmu, 'U', 1. )   ;   CALL lbc_lnk( avmv, 'V', 1. )      ! Lateral boundary conditions
-!!gm end
-
+      CALL lbc_lnk( avm_k, 'W', 1. )
+      CALL lbc_lnk( avt_k, 'W', 1. )
+      CALL lbc_lnk( avm  , 'W', 1. )
+      CALL lbc_lnk( avt  , 'W', 1. )                  !!gm  a priori only avm_k and avm are required
+      CALL lbc_lnk( avs  , 'W', 1. )                  !!gm  To be tested
+      !
 
       CALL zdf_mxl( kt )                        !* mixed layer depth, and level
 
-!!gm  !==>> to be moved in zdftke & zdfgls    
-                                                      ! write TKE or GLS information in the restart file
-      IF( lrst_oce .AND. ln_zdftke )   CALL tke_rst( kt, 'WRITE' )
-      IF( lrst_oce .AND. ln_zdfgls )   CALL gls_rst( kt, 'WRITE' )
-      !      
+
+      IF( lrst_oce ) THEN                       !* write TKE, GLS or RIC fields in the restart file
+         IF( ln_zdftke )   CALL tke_rst( kt, 'WRITE' )
+         IF( ln_zdfgls )   CALL gls_rst( kt, 'WRITE' )
+         IF( ln_zdfric )   CALL ric_rst( kt, 'WRITE' ) 
+      ENDIF
+      !
+      DEALLOCATE( zsh2 )
+      !
    END SUBROUTINE zdf_phy
 
Index: branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90
===================================================================
--- branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 8054)
+++ branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfric.F90	(revision 8055)
@@ -16,11 +16,11 @@
 
    !!----------------------------------------------------------------------
+   !!   zdf_ric_init  : initialization, namelist read, & parameters control
    !!   zdf_ric       : update momentum and tracer Kz from the Richardson number
-   !!   zdf_ric_init  : initialization, namelist read, & parameters control
+   !!   ric_rst       : read/write RIC restart in ocean restart file
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and tracers variables
    USE dom_oce        ! ocean space and time domain variables
    USE zdf_oce        ! vertical physics: variables
-   USE zdfsh2         ! vertical physics: shear production term of TKE
    USE phycst         ! physical constants
    USE sbc_oce,  ONLY :   taum
@@ -28,6 +28,5 @@
    !
    USE in_out_manager ! I/O manager
-   USE lbclnk         ! ocean lateral boundary condition (or mpp link)
-   USE lib_mpp        ! MPP library
+   USE iom            ! I/O manager library
    USE timing         ! Timing
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
@@ -37,6 +36,7 @@
    PRIVATE
 
-   PUBLIC   zdf_ric         ! called by step.F90
-   PUBLIC   zdf_ric_init    ! called by opa.F90
+   PUBLIC   zdf_ric         ! called by zdfphy.F90
+   PUBLIC   ric_rst         ! called by zdfphy.F90
+   PUBLIC   zdf_ric_init    ! called by nemogcm.F90
 
    !                        !!* Namelist namzdf_ric : Richardson number dependent Kz *
@@ -52,5 +52,5 @@
 
    !! * Substitutions
-#  include "vectopt_loop_substitute.h90"
+#  include "domain_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2011)
@@ -59,104 +59,4 @@
    !!----------------------------------------------------------------------
 CONTAINS
-
-   SUBROUTINE zdf_ric( kt )
-      !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE zdfric  ***
-      !!                    
-      !! ** Purpose :   Compute the before eddy viscosity and diffusivity as
-      !!                a function of the local richardson number.
-      !!
-      !! ** Method  :   Local richardson number dependent formulation of the 
-      !!                vertical eddy viscosity and diffusivity coefficients. 
-      !!                The eddy coefficients are given by:
-      !!                    avm = avm0 + avmb
-      !!                    avt = avm0 / (1 + rn_alp*ri)
-      !!                with ri  = N^2 / dz(u)**2
-      !!                         = e3w**2 * rn2/[ mi( dk(ub) )+mj( dk(vb) ) ]
-      !!                    avm0= rn_avmri / (1 + rn_alp*ri)**nn_ric
-      !!      Where ri is the before local Richardson number,
-      !!            rn_avmri is the maximum value reaches by avm and avt 
-      !!            avmb and avtb are the background (or minimum) values
-      !!            and rn_alp, nn_ric are adjustable parameters.
-      !!      Typical values used are : avm0=1.e-2 m2/s, avmb=1.e-6 m2/s
-      !!      avtb=1.e-7 m2/s, rn_alp=5. and nn_ric=2.
-      !!      a numerical threshold is impose on the vertical shear (1.e-20)
-      !!      As second step compute Ekman depth from wind stress forcing
-      !!      and apply namelist provided vertical coeff within this depth.
-      !!      The Ekman depth is:
-      !!              Ustar = SQRT(Taum/rho0)
-      !!              ekd= rn_ekmfc * Ustar / f0
-      !!      Large et al. (1994, eq.29) suggest rn_ekmfc=0.7; however, the derivation
-      !!      of the above equation indicates the value is somewhat arbitrary; therefore
-      !!      we allow the freedom to increase or decrease this value, if the
-      !!      Ekman depth estimate appears too shallow or too deep, respectively.
-      !!      Ekd is then limited by rn_mldmin and rn_mldmax provided in the
-      !!      namelist
-      !!        N.B. the mask are required for implicit scheme, and surface
-      !!      and bottom value already set in zdfphy.F90
-      !!
-      !! ** Action  :   avm, avt  mixing coeff (inner domain values only)
-      !!
-      !! References : Pacanowski & Philander 1981, JPO, 1441-1451.
-      !!              PFJ Lermusiaux 2001.
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   ! ocean time-step
-      !!
-      INTEGER  ::   ji, jj, jk                 ! dummy loop indices
-      LOGICAL  ::   ll_av_weight = .TRUE.      ! local logical
-      REAL(wp) ::   zcfRi, zav, zustar   ! local scalars
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zh_ekm   ! 2D workspace
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zsh2     ! 3D     -
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )   CALL timing_start('zdf_ric')
-      !
-      !                       !==  avm and avt = F(Richardson number)  ==!
-      !
-      !                          !* Shear production at uw- and vw-points (energy conserving form)
-      CALL zdf_sh2( zsh2 )
-      !
-      DO jk = 2, jpkm1           !* Vertical eddy viscosity and diffusivity coefficients
-         DO jj = 1, jpjm1
-            DO ji = 1, jpim1
-               !                          ! coefficient = F(richardson number) (avm-weighted Ri)
-               zcfRi = 1._wp / (  1._wp + rn_alp * MAX(  0._wp , avm(ji,jj,jk) * rn2(ji,jj,jk) / ( zsh2(ji,jj,jk) + 1.e-20 ) )  )
-               zav   = rn_avmri * zcfRi**nn_ric
-               !
-               !                          ! avm and avt coefficients
-               avm(ji,jj,jk) = MAX(  zav         , avmb(jk)  ) * wmask(ji,jj,jk)
-               avt(ji,jj,jk) = MAX(  zav * zcfRi , avtb(jk)  ) * wmask(ji,jj,jk)
-            END DO
-         END DO
-      END DO
-      !
-!!gm BUG <<<<====  This param can't work at low latitude 
-!!gm               it provides there much to thick mixed layer ( summer 150m in GYRE configuration !!! )
-      !
-      IF( ln_mldw ) THEN      !==  set a minimum value in the Ekman layer  ==!
-         !
-         DO jj = 2, jpjm1        !* Ekman depth
-            DO ji = 2, jpim1
-               zustar = SQRT( taum(ji,jj) * r1_rau0 )
-               zh_ekm(ji,jj) = rn_ekmfc * zustar / ( ABS( ff_t(ji,jj) ) + rsmall )     ! Ekman depth
-               zh_ekm(ji,jj) = MAX(  rn_mldmin , MIN( zh_ekm(ji,jj) , rn_mldmax )  )   ! set allowed rang
-            END DO
-         END DO
-         DO jk = 2, jpkm1        !* minimum mixing coeff. within the Ekman layer
-            DO jj = 2, jpjm1
-               DO ji = 2, jpim1
-                  IF( gdept_n(ji,jj,jk) < zh_ekm(ji,jj) ) THEN
-                     avm(ji,jj,jk) = MAX(  avm(ji,jj,jk), rn_wvmix  ) * wmask(ji,jj,jk)
-                     avt(ji,jj,jk) = MAX(  avt(ji,jj,jk), rn_wtmix  ) * wmask(ji,jj,jk)
-                  ENDIF
-               END DO
-            END DO
-         END DO
-      ENDIF
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('zdf_ric')
-      !
-   END SUBROUTINE zdf_ric
-
 
    SUBROUTINE zdf_ric_init
@@ -205,10 +105,143 @@
       ENDIF
       !
-      DO jk = 1, jpk                 ! Initialization of vertical eddy coef. to the background value
-         avt(:,:,jk) = avtb(jk) * tmask(:,:,jk)
-         avm(:,:,jk) = avmb(jk) * umask(:,:,jk)
+      CALL ric_rst( nit000, 'READ' )  !* read or initialize all required files
+      !
+   END SUBROUTINE zdf_ric_init
+
+
+   SUBROUTINE zdf_ric( ARG_2D, kt, pdept, p_sh2, p_avm, p_avt )
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE zdfric  ***
+      !!                    
+      !! ** Purpose :   Compute the before eddy viscosity and diffusivity as
+      !!                a function of the local richardson number.
+      !!
+      !! ** Method  :   Local richardson number dependent formulation of the 
+      !!                vertical eddy viscosity and diffusivity coefficients. 
+      !!                The eddy coefficients are given by:
+      !!                    avm = avm0 + avmb
+      !!                    avt = avm0 / (1 + rn_alp*ri)
+      !!                with Ri  = N^2 / dz(u)**2
+      !!                         = e3w**2 * rn2/[ mi( dk(ub) )+mj( dk(vb) ) ]
+      !!                    avm0= rn_avmri / (1 + rn_alp*Ri)**nn_ric
+      !!                where ri is the before local Richardson number,
+      !!                rn_avmri is the maximum value reaches by avm and avt 
+      !!                and rn_alp, nn_ric are adjustable parameters.
+      !!                Typical values : rn_alp=5. and nn_ric=2.
+      !!
+      !!      As second step compute Ekman depth from wind stress forcing
+      !!      and apply namelist provided vertical coeff within this depth.
+      !!      The Ekman depth is:
+      !!              Ustar = SQRT(Taum/rho0)
+      !!              ekd= rn_ekmfc * Ustar / f0
+      !!      Large et al. (1994, eq.29) suggest rn_ekmfc=0.7; however, the derivation
+      !!      of the above equation indicates the value is somewhat arbitrary; therefore
+      !!      we allow the freedom to increase or decrease this value, if the
+      !!      Ekman depth estimate appears too shallow or too deep, respectively.
+      !!      Ekd is then limited by rn_mldmin and rn_mldmax provided in the
+      !!      namelist
+      !!        N.B. the mask are required for implicit scheme, and surface
+      !!      and bottom value already set in zdfphy.F90
+      !!
+      !! ** Action  :   avm, avt  mixing coeff (inner domain values only)
+      !!
+      !! References : Pacanowski & Philander 1981, JPO, 1441-1451.
+      !!              PFJ Lermusiaux 2001.
+      !!----------------------------------------------------------------------
+      INTEGER                    , INTENT(in   ) ::   ARG_2D         ! inner domain start-end i-indices
+      INTEGER                    , INTENT(in   ) ::   kt             ! ocean time-step
+      REAL(wp), DIMENSION(:,:,:) , INTENT(in   ) ::   pdept          ! depth of t-point  [m]
+      REAL(wp), DIMENSION(WRK_3D), INTENT(in   ) ::   p_sh2          ! shear production term
+      REAL(wp), DIMENSION(:,:,:) , INTENT(inout) ::   p_avm, p_avt   ! momentum and tracer Kz (w-points)
+      !!
+      INTEGER  ::   ji, jj, jk                  ! dummy loop indices
+      REAL(wp) ::   zcfRi, zav, zustar, zed     ! local scalars
+      REAL(wp), DIMENSION(WRK_2D) ::   zh_ekm   ! 2D workspace
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )   CALL timing_start('zdf_ric')
+      !
+      !                       !==  avm and avt = F(Richardson number)  ==!
+      DO jk = 2, jpkm1
+         DO jj = k_Jstr, k_Jend
+            DO ji = k_Jstr, k_Iend        ! coefficient = F(richardson number) (avm-weighted Ri)
+               zcfRi = 1._wp / (  1._wp + rn_alp * MAX(  0._wp , avm(ji,jj,jk) * rn2(ji,jj,jk) / ( p_sh2(ji,jj,jk) + 1.e-20 ) )  )
+               zav   = rn_avmri * zcfRi**nn_ric
+               !                          ! avm and avt coefficients
+               p_avm(ji,jj,jk) = MAX(  zav         , avmb(jk)  ) * wmask(ji,jj,jk)
+               p_avt(ji,jj,jk) = MAX(  zav * zcfRi , avtb(jk)  ) * wmask(ji,jj,jk)
+            END DO
+         END DO
       END DO
       !
-   END SUBROUTINE zdf_ric_init
+!!gm BUG <<<<====  This param can't work at low latitude 
+!!gm               it provides there much to thick mixed layer ( summer 150m in GYRE configuration !!! )
+      !
+      IF( ln_mldw ) THEN      !==  set a minimum value in the Ekman layer  ==!
+         !
+         DO jj = k_Jstr, k_Jend     !* Ekman depth
+            DO ji = k_Jstr, k_Iend
+               zustar = SQRT( taum(ji,jj) * r1_rau0 )
+               zed    = rn_ekmfc * zustar / ( ABS( ff_t(ji,jj) ) + rsmall )     ! Ekman depth
+               zh_ekm(ji,jj) = MAX(  rn_mldmin , MIN( zed , rn_mldmax )  )      ! set allowed range
+            END DO
+         END DO
+         DO jk = 2, jpkm1           !* minimum mixing coeff. within the Ekman layer
+            DO jj = k_Jstr, k_Jend
+               DO ji = k_Jstr, k_Iend
+                  IF( pdept(ji,jj,jk) < zh_ekm(ji,jj) ) THEN
+                     p_avm(ji,jj,jk) = MAX(  p_avm(ji,jj,jk), rn_wvmix  ) * wmask(ji,jj,jk)
+                     p_avt(ji,jj,jk) = MAX(  p_avt(ji,jj,jk), rn_wtmix  ) * wmask(ji,jj,jk)
+                  ENDIF
+               END DO
+            END DO
+         END DO
+      ENDIF
+      !
+      IF( nn_timing == 1 )   CALL timing_stop('zdf_ric')
+      !
+   END SUBROUTINE zdf_ric
+
+
+   SUBROUTINE ric_rst( kt, cdrw )
+      !!---------------------------------------------------------------------
+      !!                   ***  ROUTINE ric_rst  ***
+      !!                     
+      !! ** Purpose :   Read or write TKE file (en) in restart file
+      !!
+      !! ** Method  :   use of IOM library
+      !!                if the restart does not contain TKE, en is either 
+      !!                set to rn_emin or recomputed 
+      !!----------------------------------------------------------------------
+      INTEGER         , INTENT(in) ::   kt     ! ocean time-step
+      CHARACTER(len=*), INTENT(in) ::   cdrw   ! "READ"/"WRITE" flag
+      !
+      INTEGER ::   jit, jk    ! dummy loop indices
+      INTEGER ::   id1, id2   ! local integers
+      !!----------------------------------------------------------------------
+      !
+      IF( TRIM(cdrw) == 'READ' ) THEN        ! Read/initialise 
+         !                                   ! ---------------
+         !           !* Read the restart file
+         IF( ln_rstart ) THEN
+            id1 = iom_varid( numror, 'avt_k', ldstop = .FALSE. )
+            id2 = iom_varid( numror, 'avm_k', ldstop = .FALSE. )
+            !
+            IF( MIN( id1, id2 ) > 0 ) THEN         ! restart exists => read it
+               CALL iom_get( numror, jpdom_autoglo, 'avt_k', avt_k )
+               CALL iom_get( numror, jpdom_autoglo, 'avm_k', avm_k )
+            ENDIF
+         ENDIF
+         !           !* otherwise Kz already set to the background value in zdf_phy_init
+         !
+      ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN   ! Create restart file
+         !                                   ! -------------------
+         IF(lwp) WRITE(numout,*) '---- ric-rst ----'
+         CALL iom_rstput( kt, nitrst, numrow, 'avt_k', avt_k )
+         CALL iom_rstput( kt, nitrst, numrow, 'avm_k', avm_k )
+         !
+      ENDIF
+      !
+   END SUBROUTINE ric_rst
 
    !!======================================================================
Index: branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfsh2.F90
===================================================================
--- branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfsh2.F90	(revision 8054)
+++ branches/2017/wrk_OMP_test_for_Silvia/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfsh2.F90	(revision 8055)
@@ -5,5 +5,5 @@
    !!=====================================================================
    !! History :   -   !  2014-10  (A. Barthelemy, G. Madec)  original code
-   !!   NEMO     4.0  !  2017-04  (G. Madec)  remove u-,v-pts avm
+   !!   NEMO     4.0  !  2017-04  (G. Madec)  remove u-,v-pts avm + ready for coarse-grained Open-MP
    !!----------------------------------------------------------------------
 
@@ -11,7 +11,5 @@
    !!   zdf_sh2       : compute mixing the shear production term of TKE
    !!----------------------------------------------------------------------
-   USE oce            ! ocean: shared variables
    USE dom_oce        ! domain: ocean
-   USE zdf_oce        ! vertical physics: variables
    !
    USE in_out_manager ! I/O manager
@@ -23,5 +21,7 @@
 
    PUBLIC   zdf_sh2        ! called by zdftke, zdfglf, and zdfric
-   
+
+   !! * Substitutions
+#  include "domain_substitute.h90"   
    !!----------------------------------------------------------------------
    !! NEMO/OPA 4.0 , NEMO Consortium (2017)
@@ -31,5 +31,5 @@
 CONTAINS
 
-   SUBROUTINE zdf_sh2(  psh2  ) 
+   SUBROUTINE zdf_sh2( ARG_2D, pub, pvb, pun, pvn, p_avm, p_sh2  ) 
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE zdf_sh2  ***
@@ -46,30 +46,34 @@
       !!                NB: wet-point only horizontal averaging of shear
       !!
-      !! ** Action  : - psh2 shear prod. term at w-point (interior ocean domain only)
-      !!
+      !! ** Action  : - p_sh2 shear prod. term at w-point (inner domain only)
+      !!                                                   *****
       !! References :   Bruchard, OM 2002
       !! ---------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(  out) ::   psh2   ! shear production of TKE (w-points)
+      INTEGER                    , INTENT(in   ) ::   ARG_2D               ! inner domain start-end i-indices
+      REAL(wp), DIMENSION(:,:,:) , INTENT(in   ) ::   pub, pvb, pun, pvn   ! before, now horizontal velocities
+      REAL(wp), DIMENSION(:,:,:) , INTENT(in   ) ::   p_avm                ! vertical eddy viscosity (w-points)
+      REAL(wp), DIMENSION(WRK_3D), INTENT(  out) ::   p_sh2                ! shear production of TKE (w-points)
       !
-      INTEGER  ::   ji, jj, jk   ! dummy loop arguments
-      REAL(wp), DIMENSION(jpi,jpj) ::   zsh2u, zsh2v   ! 2D workspace
+      INTEGER  ::   ji, jj, jk                           ! dummy loop indices
+      REAL(wp), DIMENSION(WRK_2De(-1,)) ::   zsh2u, zsh2v   ! 2D workspace
       !!--------------------------------------------------------------------
+      !
       IF( nn_timing == 1 )  CALL timing_start('zdf_sh2')
       !
       DO jk = 2, jpkm1
-         DO jj = 1, jpjm1        !* 2 x shear production at uw- and vw-points (energy conserving form)
-            DO ji = 1, jpim1
-               zsh2u(ji,jj) = ( avm(ji+1,jj,jk) + avm(ji,jj,jk) ) &
-                  &         * (  un(ji,jj,jk-1) -  un(ji,jj,jk) ) &
-                  &         * (  ub(ji,jj,jk-1) -  ub(ji,jj,jk) ) / ( e3uw_n(ji,jj,jk) * e3uw_b(ji,jj,jk) ) * wumask(ji,jj,jk) 
-               zsh2v(ji,jj) = ( avm(ji,jj+1,jk) + avm(ji,jj,jk) ) &
-                  &         * (  vn(ji,jj,jk-1) -  vn(ji,jj,jk) ) &
-                  &         * (  vb(ji,jj,jk-1) -  vb(ji,jj,jk) ) / ( e3vw_n(ji,jj,jk) * e3vw_b(ji,jj,jk) ) * wvmask(ji,jj,jk)
+         DO jj = k_Jstr-1, k_Jend      !* 2 x shear production at uw- and vw-points (energy conserving form)
+            DO ji = k_Istr-1, k_Iend
+               zsh2u(ji,jj) = ( p_avm(ji+1,jj,jk) + p_avm(ji,jj,jk) ) &
+                  &         * (   pun(ji,jj,jk-1) -   pun(ji,jj,jk) ) &
+                  &         * (   pub(ji,jj,jk-1) -   pub(ji,jj,jk) ) / ( e3uw_n(ji,jj,jk) * e3uw_b(ji,jj,jk) ) * wumask(ji,jj,jk)
+               zsh2v(ji,jj) = ( p_avm(ji,jj+1,jk) + p_avm(ji,jj,jk) ) &
+                  &         * (   pvn(ji,jj,jk-1) -   pvn(ji,jj,jk) ) &
+                  &         * (   pvb(ji,jj,jk-1) -   pvb(ji,jj,jk) ) / ( e3vw_n(ji,jj,jk) * e3vw_b(ji,jj,jk) ) * wvmask(ji,jj,jk)
             END DO
          END DO
-         DO jj = 2, jpjm1        !* shear production at w-point
-            DO ji = 2, jpim1           ! coast mask: =2 at the coast ; =1 otherwise (NB: wmask useless as zsh2 are masked)
-               psh2(ji,jj,jk) = 0.25 * (   ( zsh2u(ji-1,jj) + zsh2u(ji,jj) ) * ( 2. - umask(ji-1,jj,jk) * umask(ji,jj,jk) )   &
-                  &                      + ( zsh2v(ji,jj-1) + zsh2v(ji,jj) ) * ( 2. - vmask(ji,jj-1,jk) * vmask(ji,jj,jk) )   )
+         DO jj = k_Jstr, k_Jend        !* shear production at w-point
+            DO ji = k_Jstr, k_Iend           ! coast mask: =2 at the coast ; =1 otherwise (NB: wmask useless as zsh2 are masked)
+               p_sh2(ji,jj,jk) = 0.25 * (   ( zsh2u(ji-1,jj) + zsh2u(ji,jj) ) * ( 2. - umask(ji-1,jj,jk) * umask(ji,jj,jk) )   &
+                  &                       + ( zsh2v(ji,jj-1) + zsh2v(ji,jj) ) * ( 2. - vmask(ji,jj-1,jk) * vmask(ji,jj,jk) )   )
             END DO
          END DO
